Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/RandExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/RandExpressions.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/RandExpressions.cs	(revision 14513)
@@ -1,87 +1,103 @@
-﻿using HeuristicLab.Algorithms.PushGP.Generators;
-using HeuristicLab.Algorithms.PushGP.Interpreter;
+﻿namespace HeuristicLab.Algorithms.PushGP.Expressions
+{
+  using HeuristicLab.Algorithms.PushGP.Generators;
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
-{
-    /// <summary>
-    /// Pushes a random NAME.
-    /// </summary>
-    public class NameRandExpression : StatelessExpression
+  /// <summary>
+  ///     Pushes a random NAME.
+  /// </summary>
+  public class NameRandExpression : StatelessExpression
+  {
+    protected override string InitStringRepresentation()
     {
-        protected override string InitStringRepresentation() { return "NAME.RAND"; }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            var name = NameGenerator.RandomName();
-
-            interpreter.NameStack.Push(name);
-        }
+      return "NAME.RAND";
     }
 
-    /// <summary>
-    /// Pushes a random integer.
-    /// </summary>
-    public class IntegerRandExpression : StatelessExpression
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "INTEGER.RAND"; }
+      var name = NameGenerator.RandomName();
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            var value = IntegerGenerator.RandomInteger(
-                interpreter.Configuration.MinRandomInteger,
-                interpreter.Configuration.MaxRandomInteger);
+      interpreter.NameStack.Push(name);
+    }
+  }
 
-            interpreter.IntegerStack.Push(value);
-        }
+  /// <summary>
+  ///     Pushes a random integer.
+  /// </summary>
+  public class IntegerRandExpression : StatelessExpression
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "INTEGER.RAND";
     }
 
-    /// <summary>
-    /// Pushes a random float.
-    /// </summary>
-    public class FloatRandExpression : StatelessExpression
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "FLOAT.RAND"; }
+      var value = IntegerGenerator.RandomInteger(
+        interpreter.Configuration.MinRandomInteger,
+        interpreter.Configuration.MaxRandomInteger);
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            var value = FloatGenerator.RandomFloat(
-                interpreter.Configuration.MinRandomFloat,
-                interpreter.Configuration.MaxRandomFloat);
+      interpreter.IntegerStack.Push(value);
+    }
+  }
 
-            interpreter.FloatStack.Push(value);
-        }
+  /// <summary>
+  ///     Pushes a random float.
+  /// </summary>
+  public class FloatRandExpression : StatelessExpression
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "FLOAT.RAND";
     }
 
-    /// <summary>
-    /// Pushes a random boolean.
-    /// </summary>
-    public class BooleanRandExpression : StatelessExpression
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "BOOLEAN.RAND"; }
+      var value = FloatGenerator.RandomFloat(
+        interpreter.Configuration.MinRandomFloat,
+        interpreter.Configuration.MaxRandomFloat);
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            var value = BooleanGenerator.RandomBoolean();
+      interpreter.FloatStack.Push(value);
+    }
+  }
 
-            interpreter.BooleanStack.Push(value);
-        }
+  /// <summary>
+  ///     Pushes a random boolean.
+  /// </summary>
+  public class BooleanRandExpression : StatelessExpression
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "BOOLEAN.RAND";
     }
 
-    /// <summary>
-    /// Pushes random expressions onto the code stack.
-    /// </summary>
-    public class CodeRandExpression : StatelessExpression
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "CODE.RAND"; }
+      var value = BooleanGenerator.RandomBoolean();
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            if (interpreter.IntegerStack.Count == 0 ||
-                interpreter.IntegerStack.Top < 1)
-                return;
+      interpreter.BooleanStack.Push(value);
+    }
+  }
 
-            var size = (int)(interpreter.IntegerStack.Pop() % interpreter.Configuration.MaxPointsInRandomExpression);
-            var expression = interpreter.CodeGenerator.RandomCode(size);
-        }
+  /// <summary>
+  ///     Pushes random expressions onto the code stack.
+  /// </summary>
+  public class CodeRandExpression : StatelessExpression
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "CODE.RAND";
     }
+
+    public override void Eval(IPushGpInterpreter interpreter)
+    {
+      if ((interpreter.IntegerStack.Count == 0) || (interpreter.IntegerStack.Top < 1)) return;
+
+      var size = (int)(interpreter.IntegerStack.Pop() % interpreter.Configuration.MaxPointsInRandomExpression);
+
+      var expression = CodeGenerator.RandomProgram(size, interpreter.CustomExpressions);
+
+      interpreter.CodeStack.Push(expression);
+    }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/RotateExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/RotateExpressions.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/RotateExpressions.cs	(revision 14513)
@@ -1,76 +1,93 @@
-﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
-using HeuristicLab.Algorithms.PushGP.Stack;
+﻿namespace HeuristicLab.Algorithms.PushGP.Expressions
+{
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+  using HeuristicLab.Algorithms.PushGP.Stack;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
-{
-    public abstract class RotateExpression<T> : StatelessExpression
+  public abstract class RotateExpression<T> : StatelessExpression
+  {
+    public void Eval(IStack<T> stack)
     {
-        public void Eval(IStack<T> stack)
-        {
-            if (stack.Count < 3)
-                return;
+      if (stack.Count < 3) return;
 
-            stack.Swap(3);
-        }
+      stack.Swap(3);
+    }
+  }
+
+  public class IntegerRotateExpression : RotateExpression<long>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "INTEGER.ROT";
     }
 
-    public class IntegerRotateExpression : RotateExpression<long>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "INTEGER.ROT"; }
+      this.Eval(interpreter.IntegerStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.IntegerStack);
-        }
+  public class FloatRotateExpression : RotateExpression<double>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "FLOAT.ROT";
     }
 
-    public class FloatRotateExpression : RotateExpression<double>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "FLOAT.ROT"; }
+      this.Eval(interpreter.FloatStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.FloatStack);
-        }
+  public class BooleanRotateExpression : RotateExpression<bool>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "BOOLEAN.ROT";
     }
 
-    public class BooleanRotateExpression : RotateExpression<bool>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "BOOLEAN.ROT"; }
+      this.Eval(interpreter.BooleanStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.BooleanStack);
-        }
+  public class NameRotateExpression : RotateExpression<string>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "NAME.ROT";
     }
 
-    public class NameRotateExpression : RotateExpression<string>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "NAME.ROT"; }
+      this.Eval(interpreter.NameStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.NameStack);
-        }
+  public class ExecRotateExpression : RotateExpression<Expression>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "EXEC.ROT";
     }
 
-    public class ExecRotateExpression : RotateExpression<Expression>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "EXEC.ROT"; }
+      this.Eval(interpreter.ExecStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.ExecStack);
-        }
+  public class CodeRotateExpression : RotateExpression<Expression>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "CODE.ROT";
     }
 
-    public class CodeRotateExpression : RotateExpression<Expression>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "CODE.ROT"; }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.CodeStack);
-        }
+      this.Eval(interpreter.CodeStack);
     }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ShoveExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ShoveExpressions.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ShoveExpressions.cs	(revision 14513)
@@ -1,85 +1,98 @@
-﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
-using HeuristicLab.Algorithms.PushGP.Stack;
+﻿namespace HeuristicLab.Algorithms.PushGP.Expressions
+{
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+  using HeuristicLab.Algorithms.PushGP.Stack;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
-{
-    public abstract class ShoveExpression<T> : StatelessExpression
+  public abstract class ShoveExpression<T> : StatelessExpression
+  {
+    public void Eval(IStack<T> stack, IStack<long> integerStack, int count = 1)
     {
-        public void Eval(IStack<T> stack, IStack<long> integerStack, int count = 1)
-        {
-            if (integerStack.Count == 0)
-                return;
+      if (integerStack.Count == 0) return;
 
-            if (integerStack.Top > stack.Count - count ||
-                integerStack.Top < 0 ||
-                stack.Count < 2)
-                return;
+      if ((integerStack.Top > stack.Count - count) || (integerStack.Top < 0) || (stack.Count < 2)) return;
 
-            var index = integerStack.Pop();
-            var item = stack.Pop();
+      var index = (int)integerStack.Pop();
+      var item = stack.Pop();
 
-            // TODO: What if index > int.MaxValue ?
-            stack.Insert((int)index, item);
-        }
+      stack.Insert(index, item);
+    }
+  }
+
+  public class IntegerShoveExpression : ShoveExpression<long>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "INTEGER.SHOVE";
     }
 
-    public class IntegerShoveExpression : ShoveExpression<long>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "INTEGER.SHOVE"; }
+      this.Eval(interpreter.IntegerStack, interpreter.IntegerStack, 2);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.IntegerStack, interpreter.IntegerStack, 2);
-        }
+  public class FloatShoveExpression : ShoveExpression<double>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "FLOAT.SHOVE";
     }
 
-    public class FloatShoveExpression : ShoveExpression<double>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "FLOAT.SHOVE"; }
+      this.Eval(interpreter.FloatStack, interpreter.IntegerStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.FloatStack, interpreter.IntegerStack);
-        }
+  public class BooleanShoveExpression : ShoveExpression<bool>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "BOOLEAN.SHOVE";
     }
 
-    public class BooleanShoveExpression : ShoveExpression<bool>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "BOOLEAN.SHOVE"; }
+      this.Eval(interpreter.BooleanStack, interpreter.IntegerStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.BooleanStack, interpreter.IntegerStack);
-        }
+  public class NameShoveExpression : ShoveExpression<string>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "NAME.SHOVE";
     }
 
-    public class NameShoveExpression : ShoveExpression<string>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "NAME.SHOVE"; }
+      this.Eval(interpreter.NameStack, interpreter.IntegerStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.NameStack, interpreter.IntegerStack);
-        }
+  public class ExecShoveExpression : ShoveExpression<Expression>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "EXEC.SHOVE";
     }
 
-    public class ExecShoveExpression : ShoveExpression<Expression>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "EXEC.SHOVE"; }
+      this.Eval(interpreter.ExecStack, interpreter.IntegerStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.ExecStack, interpreter.IntegerStack);
-        }
+  public class CodeShoveExpression : ShoveExpression<Expression>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "CODE.SHOVE";
     }
 
-    public class CodeShoveExpression : ShoveExpression<Expression>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "CODE.SHOVE"; }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.CodeStack, interpreter.IntegerStack);
-        }
+      this.Eval(interpreter.CodeStack, interpreter.IntegerStack);
     }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/StackdepthExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/StackdepthExpressions.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/StackdepthExpressions.cs	(revision 14513)
@@ -1,84 +1,78 @@
-﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
-using HeuristicLab.Algorithms.PushGP.Stack;
+﻿namespace HeuristicLab.Algorithms.PushGP.Expressions {
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+  using HeuristicLab.Algorithms.PushGP.Stack;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
-{
-    /// <summary>
-    /// Pushes the stack depth onto the INTEGER stack (thereby increasing it!).
-    /// </summary>
-    /// <typeparam name="T">Stacktype</typeparam>
-    public abstract class StackdepthExpression<T> : StatelessExpression
-    {
-        public void Eval(IStack<T> stack, IStack<long> integerStack, bool incremental = false)
-        {
-            var count = stack.Count;
+  /// <summary>
+  ///     Pushes the stack depth onto the INTEGER stack (thereby increasing it!).
+  /// </summary>
+  /// <typeparam name="T">Stacktype</typeparam>
+  public abstract class StackdepthExpression<T> : StatelessExpression {
+    public void Eval(IStack<T> stack, IStack<long> integerStack, bool incremental = false) {
+      var count = stack.Count;
 
-            if (incremental)
-            {
-                count += 1;
-            }
+      if (incremental) count += 1;
 
-            integerStack.Push(count);
-        }
+      integerStack.Push(count);
+    }
+  }
+
+  public class IntegerStackdepthExpression : StackdepthExpression<long> {
+    protected override string InitStringRepresentation() {
+      return "INTEGER.STACKDEPTH";
     }
 
-    public class IntegerStackdepthExpression : StackdepthExpression<long>
-    {
-        protected override string InitStringRepresentation() { return "INTEGER.STACKDEPTH"; }
+    public override void Eval(IPushGpInterpreter interpreter) {
+      this.Eval(interpreter.IntegerStack, interpreter.IntegerStack, true);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.IntegerStack, interpreter.IntegerStack, true);
-        }
+  public class FloatStackdepthExpression : StackdepthExpression<double> {
+    protected override string InitStringRepresentation() {
+      return "FLOAT.STACKDEPTH";
     }
 
-    public class FloatStackdepthExpression : StackdepthExpression<double>
-    {
-        protected override string InitStringRepresentation() { return "FLOAT.STACKDEPTH"; }
+    public override void Eval(IPushGpInterpreter interpreter) {
+      this.Eval(interpreter.FloatStack, interpreter.IntegerStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.FloatStack, interpreter.IntegerStack);
-        }
+  public class BooleanStackdepthExpression : StackdepthExpression<bool> {
+    protected override string InitStringRepresentation() {
+      return "BOOLEAN.STACKDEPTH";
     }
 
-    public class BooleanStackdepthExpression : StackdepthExpression<bool>
-    {
-        protected override string InitStringRepresentation() { return "BOOLEAN.STACKDEPTH"; }
+    public override void Eval(IPushGpInterpreter interpreter) {
+      this.Eval(interpreter.BooleanStack, interpreter.IntegerStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.BooleanStack, interpreter.IntegerStack);
-        }
+  public class NameStackdepthExpression : StackdepthExpression<string> {
+    protected override string InitStringRepresentation() {
+      return "NAME.STACKDEPTH";
     }
 
-    public class NameStackdepthExpression : StackdepthExpression<string>
-    {
-        protected override string InitStringRepresentation() { return "NAME.STACKDEPTH"; }
+    public override void Eval(IPushGpInterpreter interpreter) {
+      this.Eval(interpreter.NameStack, interpreter.IntegerStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.NameStack, interpreter.IntegerStack);
-        }
+  public class ExecStackdepthExpression : StackdepthExpression<Expression> {
+    protected override string InitStringRepresentation() {
+      return "EXEC.STACKDEPTH";
     }
 
-    public class ExecStackdepthExpression : StackdepthExpression<Expression>
-    {
-        protected override string InitStringRepresentation() { return "EXEC.STACKDEPTH"; }
+    public override void Eval(IPushGpInterpreter interpreter) {
+      this.Eval(interpreter.ExecStack, interpreter.IntegerStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.ExecStack, interpreter.IntegerStack);
-        }
+  public class CodeStackdepthExpression : StackdepthExpression<Expression> {
+    protected override string InitStringRepresentation() {
+      return "CODE.STACKDEPTH";
     }
 
-    public class CodeStackdepthExpression : StackdepthExpression<Expression>
-    {
-        protected override string InitStringRepresentation() { return "CODE.STACKDEPTH"; }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.CodeStack, interpreter.IntegerStack);
-        }
+    public override void Eval(IPushGpInterpreter interpreter) {
+      this.Eval(interpreter.CodeStack, interpreter.IntegerStack);
     }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/StatefullExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/StatefullExpression.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/StatefullExpression.cs	(revision 14513)
@@ -1,13 +1,13 @@
-﻿using HeuristicLab.Common;
+﻿namespace HeuristicLab.Algorithms.PushGP.Expressions {
+  public abstract class StatefullExpression<T> : Expression {
+    protected T State { get; set; }
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
-{
-    public abstract class StatefullExpression : Expression
-    {
-        protected StatefullExpression()
-        { }
+    protected StatefullExpression(T state) {
+      this.State = state;
+    }
 
-        protected StatefullExpression(StatefullExpression origin, Cloner cloner) : base(origin, cloner)
-        { }
+    public override string ToString() {
+      return this.State.ToString();
     }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/StatelessExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/StatelessExpression.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/StatelessExpression.cs	(revision 14513)
@@ -1,17 +1,11 @@
-﻿using HeuristicLab.Common;
+﻿namespace HeuristicLab.Algorithms.PushGP.Expressions {
+  public abstract class StatelessExpression : Expression {
+    protected override int InitId() {
+      return this.GetType().GetHashCode();
+    }
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
-{
-    public abstract class StatelessExpression : Expression
-    {
-        protected override int InitId()
-        {
-            return StringRepresentation.GetHashCode();
-        }
-
-        public override IDeepCloneable Clone(Cloner cloner)
-        {
-            return this;
-        }
+    public override string ToString() {
+      return this.StringRepresentation;
     }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/SwapExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/SwapExpressions.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/SwapExpressions.cs	(revision 14513)
@@ -1,80 +1,97 @@
-﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
-using HeuristicLab.Algorithms.PushGP.Stack;
+﻿namespace HeuristicLab.Algorithms.PushGP.Expressions
+{
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+  using HeuristicLab.Algorithms.PushGP.Stack;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
-{
-    /// <summary>
-    /// Swaps the top two values.
-    /// </summary>
-    /// <typeparam name="T">Stacktype</typeparam>
-    public abstract class SwapExpression<T> : StatelessExpression
+  /// <summary>
+  ///     Swaps the top two values.
+  /// </summary>
+  /// <typeparam name="T">Stacktype</typeparam>
+  public abstract class SwapExpression<T> : StatelessExpression
+  {
+    public void Eval(IStack<T> stack)
     {
-        public void Eval(IStack<T> stack)
-        {
-            if (stack.Count < 2)
-                return;
+      if (stack.Count < 2) return;
 
-            stack.Swap(2);
-        }
+      stack.Swap(2);
+    }
+  }
+
+  public class IntegerSwapExpression : SwapExpression<long>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "INTEGER.SWAP";
     }
 
-    public class IntegerSwapExpression : SwapExpression<long>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "INTEGER.SWAP"; }
+      this.Eval(interpreter.IntegerStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.IntegerStack);
-        }
+  public class FloatSwapExpression : SwapExpression<double>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "FLOAT.SWAP";
     }
 
-    public class FloatSwapExpression : SwapExpression<double>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "FLOAT.SWAP"; }
+      this.Eval(interpreter.FloatStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.FloatStack);
-        }
+  public class BooleanSwapExpression : SwapExpression<bool>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "BOOLEAN.SWAP";
     }
 
-    public class BooleanSwapExpression : SwapExpression<bool>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "BOOLEAN.SWAP"; }
+      this.Eval(interpreter.BooleanStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.BooleanStack);
-        }
+  public class NameSwapExpression : SwapExpression<string>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "NAME.SWAP";
     }
 
-    public class NameSwapExpression : SwapExpression<string>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "NAME.SWAP"; }
+      this.Eval(interpreter.NameStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.NameStack);
-        }
+  public class ExecSwapExpression : SwapExpression<Expression>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "EXEC.SWAP";
     }
 
-    public class ExecSwapExpression : SwapExpression<Expression>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "EXEC.SWAP"; }
+      this.Eval(interpreter.ExecStack);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.ExecStack);
-        }
+  public class CodeSwapExpression : SwapExpression<Expression>
+  {
+    protected override string InitStringRepresentation()
+    {
+      return "CODE.SWAP";
     }
 
-    public class CodeSwapExpression : SwapExpression<Expression>
+    public override void Eval(IPushGpInterpreter interpreter)
     {
-        protected override string InitStringRepresentation() { return "CODE.SWAP"; }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.CodeStack);
-        }
+      this.Eval(interpreter.CodeStack);
     }
+  }
 }
